
#ifndef W83977AF_IRH
#define W83977AF_IRH

#define SSR 	3
#define SET0 	0x00
#define SET1	0x80
#define SET2	0xE0
#define SET3	0xE4
#define SET4	0xE8
#define SET5	0xEC
#define SET6	0xF0
#define SET7	0xF4


/* Flags for configuration register CRF0 */
#define APEDCRC		0x02
#define ENBNKSEL	0x01


/* Set 0 */

#define ICR		0x01
#define ICR_EDMAI	0x10
#define ICR_EHSRI	0x04

#define FCR		0x02
#define FCR_RXTL10	0x80
#define FCR_TXTL10	0x20

#define ISR		0x02
#define ISR_RXTH_I	0x01
#define ISR_FEND_I	0x04
#define ISR_DMA_I	0x10
#define ISR_TXTH_I	0x20

#define HCR		0x04
#define HCR_MODE_MASK	~(0xD0)
#define HCR_MIR_576  	0x20	
#define HCR_MIR_1152	0x80
#define HCR_FIR		0xA0
#define HCR_EN_DMA	0x04
#define HCR_EN_IRQ	0x08	


/* Set 2 */
#define ADCR1		0x02
#define ADCR1_ADV_SL	0x01	
#define ADCR1_D_CHSW	0x08	/* the specs are wrong. its bit 3, not 4 */
#define ADCR1_DMA_F	0x02

#define ADCR2		0x04
#define ADCR2_TXFS32	0x01
#define ADCR2_RXFS32	0x04

/* Set 3 */
#define AUID		0x00

/* Set 4 */
#define TFRLL		0x04
#define TFRLH		0x05
#define RFRLL		0x06
#define RFRLH		0x07

/* Set 6 */
#define IR_CFG2		0x00
#define IR_CFG2_DIS_CRC	0x02

/* Set 7 */
#define IRM_CR		0x07
#define IRM_CR_IRX_MSL	0x40

#include <asm/io.h>

static inline void register_bank(int port, int set)
{
	outb(set, port+SSR);
}

static inline unsigned int serial_in(int port, int offset)
{
        return inb(port+offset);
}

static inline void serial_out(int port, int offset, int value)
{
        outb(value, port+offset);
}

#endif
